#!/usr/bin/python3

from goprocam import GoProCamera
from goprocam import constants


import os
import sys
import re
import time
import netifaces

BACKUPPATH="/backup"
log_ptr=None

def msg(str):
   global log_ptr
   if log_ptr!=None:
      log_ptr=str
   else:
      print(str)


def run(folder_dst=None,ptr=None):
 
   global BACKUPPATH   
   if (ptr):
      log_ptr=ptr
 
   if folder_dst==None:
      msg ("Generating generic folder...")
      for i in range (0,1000):
         folder_dst=BACKUPPATH+"/CP_"+str(i)
         #if not(os.path.isdir(BACKUPPATH+"/CP_"+str(i))) or  not(os.path.exists(BACKUPPATH+"/CP_"+str(i))):
         if not(os.path.isdir(folder_dst)) or  not(os.path.exists(folder_dst)):
            break
      if i==1000:
         msg ("Can not generate CP_[0:1000]")
         return
      else:
         msg ("Done")
       
   elif os.path.isdir(folder_dst):
      msg ("directroy exist "+folder_dst+" exiting..")
      return
   elif os.path.exists(folder_dst):
      msg ("file exist "+folder_dst+" exiting..")
      return
   
   print ("mkdir "+folder_dst)
   #os.system("mkdir "+folder_dst)
   #if not os.path.exists(folder_dst):
   os.makedirs(folder_dst);
   
   msg("Checking wlan1...")  
   try:
      print(netifaces.ifaddresses('wlan1')[netifaces.AF_INET][0]['addr'])
   except:
      msg ("wlan1 not connected to Gopro SSID. exiting...")
      return
   
   
   gpCam = GoProCamera.GoPro()
   gpCam.pair(usepin=False)
   #gpCam.pair(usepin=True)
   
   
   
   msg ("Start...")
   
   localtime = time.asctime( time.localtime(time.time()) )
   start_time = time.time()
   msg ("Start time :" +str(localtime))
   gpCam.overview()
   #msg(gpCam.getMedia())
   #msg(gpCam.getMediaInfo("file"))
   gpCam.listMedia(True)
   #exit()
   
   data=gpCam.listMedia(True,True)
   for i in data:
      folder=i[0]
      if not os.path.exists(folder_dst+"/"+folder):
         os.makedirs(folder_dst+"/"+folder);
      mp4_file=i[1]
      lrv_file=re.sub(".MP4",".LRV",mp4_file) 
    
      msg("copy "+folder+"/"+mp4_file+" to "+folder_dst); 
      gpCam.downloadMedia(folder,mp4_file,folder_dst+"/"+folder+"/"+mp4_file)
      msg("copy "+folder+"/"+lrv_file+" to "+folder_dst); 
      gpCam.downloadMedia(folder,lrv_file,folder_dst+"/"+folder+"/"+lrv_file)
      if re.search("GPBK",mp4_file) or  re.search("GB",mp4_file):
         wav_file=re.sub(".MP4",".WAV",mp4_file)
         #msg("copy "+folder+"/"+wav_file+" to "+folder_dst); 
         gpCam.downloadMedia(folder,wav_file,folder_dst+"/"+folder+"/"+wav_file)
      if re.search("GPBK",mp4_file):
         thm_file=re.sub(".MP4",".THM",mp4_file) 
         #msg("copy "+folder+"/"+thm_file+" to "+folder_dst); 
         gpCam.downloadMedia(folder,thm_file,folder_dst+"/"+folder+"/"+thm_file)
      if re.search("GPFR",mp4_file):
         thm_file=re.sub(".MP4",".THM",mp4_file) 
         #msg("copy "+folder+"/"+thm_file+" to "+folder_dst); 
         gpCam.downloadMedia(folder,thm_file,folder_dst+"/"+folder+"/"+thm_file)
         
   
   
   msg ("Done")
   localtime = time.asctime( time.localtime(time.time()) )
   elapsed_time = time.time() - start_time
   msg ("End time :", localtime)
   
   
   hours, rem = divmod(elasped_time, 3600)
   minutes, seconds = divmod(rem, 60)
   msg("Elaspse time: "+"{:0>2}:{:0>2}:{:05.2f}".format(int(hours),int(minutes),seconds))
   

if __name__ == '__main__':
   if len(sys.argv) < 2:
      msg ("Usage cp_fusion_files.py <destination directory> ")
      exit()
   
   run(sys.argv[1])
    
